/***************************************************************************
 *   Copyright (C) 2005-2007 by Lisandro Damián Nicanor Pérez Meyer        *
 *   perezmeyer@gmail.com                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef MATRIX_H
#define MATRIX_H

/**
	This class holds a matrix of row x columns size.
	The matrix is accesed with values between (0..row-1, 0..column-1).
 */

class Matrix
{

public:
	/// Creates a dimension x dimension matrix
	Matrix(int dimension);
	Matrix(int columns, int rows );
	~Matrix();

	double getValue( int row, int column ) const;
	void setValue( int row, int column, double value );
	int getRows() const;
	int getColumns() const;

	void debug() const;

private:
	double * array;
	int rowCount;
	int columnCount;
};
#endif // MATRIX_H
